<script lang="ts">
import Vue from "vue";
import { SlpButton } from "slippers-ui";

import GitLabIcon from "../../assets/gitlab2.vue";
import SearchIcon from "../../assets/search.vue";
import NavigationDropdown from "@/components/Navigation/navigation-dropdown.vue";
import { FreeTrialVariant } from "@/common/constants";
import NavButton from "@/components/Common/nav-button.vue";
import SlpSearch from "../Search/search.vue";

export default Vue.extend({
  name: "SlpNavigationDesktop",
  components: {
    NavButton,
    NavigationDropdown,
    SlpSearch,
    GitLabIcon,
    SearchIcon,
    SlpButton,
  },
  props: {
    data: {
      required: true,
      type: Object,
    },
    freeTrialLink: {
      required: true,
      type: String,
    },
    hideSalesButton: {
      required: true,
      type: Boolean,
    },
    freeTrialVariant: {
      type: String,
      default: "primary",
      validator(value) {
        return Object.values(FreeTrialVariant).includes(
          value as FreeTrialVariant
        );
      },
    },
  },
  data() {
    return {
      isSearchOpen: false,
      isLoginOpen: false,
      showDropdown: false,
      focusedElementIndex: null,
      logoUrl: this.data.logo.fields.url.content[0].content[0].value,
    };
  },
  methods: {
    toggleSearch() {
      this.isSearchOpen = !this.isSearchOpen;
    },
    onKeypressEnter(currentIndex) {
      if (currentIndex === this.focusedElementIndex || null) {
        this.showDropdown = !this.showDropdown;
      } else {
        this.showDropdown = true;
      }

      this.focusedElementIndex = currentIndex;
    },
  },
});
</script>

<template>
  <div>
    <SlpSearch v-if="isSearchOpen" @close="toggleSearch" />
    <div class="be-nav-navigation" ref="navigation">
      <!-- BOTTOM NAVIGATION BAR -->
      <div class="be-nav-navigation-bottom">
        <div class="navigation-bottom-left">
          <SlpButton
            class="slp-mr-8"
            variant="icon"
            :href="logoUrl"
            data-nav="logo"
            aria-label="Home"
            name="Home"
            tabindex="0"
          >
            <GitLabIcon ariaId="tanukiHomeDesktop" />
          </SlpButton>
          <ul>
            <li
              v-for="(navItem, index) in data.navItems"
              :key="navItem.text"
              class="navigation-item"
              @keypress.enter="onKeypressEnter(index)"
            >
              <NavigationDropdown
                :item-data="navItem"
                :show-dropdown="showDropdown && focusedElementIndex === index"
              />
            </li>
          </ul>
        </div>
        <div class="navigation-bottom-right">
          <SlpButton
            variant="icon"
            aria-label="Search"
            data-nav="site search"
            @click.native="toggleSearch()"
            class="navigation__search slp-mr-24"
          >
            <SearchIcon />
          </SlpButton>
          <SlpButton
            v-if="!hideSalesButton"
            :href="data.sales.href"
            variant="secondary"
            class="slp-mr-24"
            v-bind="data.sales.headerGa"
            :name="data.sales.text"
          >
            {{ data.sales.text }}
          </SlpButton>
          <NavButton
            v-bind="data.freeTrial.headerGa"
            :name="data.freeTrial.text"
            :free-trial-variant="freeTrialVariant"
            :href="freeTrialLink"
          >
            {{ data.freeTrial.text }}
          </NavButton>
          <!-- Sign In -->
          <NavigationDropdown
            :item-data="data.login"
            :show-dropdown="showDropdown && focusedElementIndex === 'login'"
            class="slp-ml-24"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss">
$popover-width: 170px;

.be-nav-navigation {
  background-color: white;
  padding: $spacing-4 $spacing-24 $spacing-16 $spacing-24;
  backdrop-filter: blur(16px);
  -webkit-backdrop-filter: blur(16px);

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  // Override default link styling in nav
  a {
    color: $color-text-200;
  }

  &-desktop {
    overflow-x: clip;
  }

  @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
    padding: $spacing-4 $spacing-24 $spacing-16 $spacing-24;
    display: flex;
    justify-content: center;
  }

  &__login-popover {
    padding: 0 $spacing-24;
    display: flex;
    flex-direction: column;
    min-width: 240px;
  }

  &__link {
    color: $color-text-link-100;

    &:hover {
      text-decoration: underline;
    }

    &:last-of-type {
      padding-bottom: 0;
    }
  }

  &__search {
    @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
      margin-right: 0;
    }
    svg {
      color: $color-surface-500;
      transition: all 0.3s ease-in-out;

      &:hover {
        color: $color-surface-600;
      }
    }
  }
}

.be-nav-navigation-bottom {
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding-top: $spacing-16;
  width: 100%;

  &.centered {
    justify-content: center;
  }

  &__cta {
    &--accent {
      background-color: $color-accent-300 !important;
      color: $color-primary-300 !important;
      border-color: $color-accent-300 !important;

      &:hover {
        background-color: $color-primary-300 !important;
        color: $color-accent-300 !important;
      }
    }

    &--steel {
      background: linear-gradient(
        93.83deg,
        rgba(0, 0, 0, 1) 7.27%,
        rgba(0, 0, 0, 1) 105.33%
      ) !important;
      position: relative;
      overflow: hidden;

      &:after {
        content: "";
        position: absolute;
        top: 0;
        left: -200%;
        width: 200%;
        height: 100%;
        transform: skewX(-20deg);
        background-image: linear-gradient(
          to right,
          transparent,
          rgba(255, 255, 255, 0.5),
          transparent
        );
      }

      &:hover {
        background-color: $color-primary-300 !important;
        color: $color-primary-300 !important;
      }

      &:hover:after {
        animation: shine 0.8s ease-in-out;
      }
    }
  }

  .navigation-bottom-left {
    display: flex;
    align-items: center;
    color: $color-text-200 !important;

    ul {
      white-space: nowrap;
    }
  }

  .navigation-item {
    display: inline-block;

    &:not(:last-child) {
      margin-right: $spacing-16;
      @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
        margin-right: $spacing-8;
      }
    }

    &_button {
      position: relative;
      color: $color-text-200;
      transition: all 0.1s ease-in-out;

      &:hover {
        color: $color-text-300;
      }

      &--active {
        color: $color-text-300;
      }
    }
  }

  .navigation-bottom-right {
    display: flex;
    align-items: center;

    .slp-btn {
      &:not(:first-child) {
        @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
          margin-right: $spacing-8;
        }
      }
    }
  }
}

.v-popper {
  &__arrow-container {
    display: none !important;
  }

  &__popper {
    outline: none !important;
  }
}

@keyframes shine {
  100% {
    left: 200%;
  }
}
</style>
